Add Check dependencies for Fedora
[OpenSRF.git] / src / extras / Makefile.install
1 # ---------------------------------------------------------------------
2 # Author: Bill Erickson <erickson@esilibrary.com>
3 # Author: Dan Scott <dscott@laurentian.ca>
4 #
5 # Makefile to install prerequisites for OpenSRF
6 #
7 # Currently supports Debian (lenny/squeeze), Ubuntu (hardy/lucid)
8 # Working towards support of CentOS 5 / RHEL 5 and Fedora.
9 # Installs Perl prereqs, libjs with Perl wrapper
10 #
11 # usage:
12 #       make -f Makefile.install debian-lenny
13 #       - or -
14 #       make -f Makefile.install debian-squeeze
15 #       - or -
16 #       make -f Makefile.install ubuntu-hardy
17 #       - or -
18 #       make -f Makefile.install ubuntu-lucid
19 #       - or -
20 #       make -f Makefile.install centos
21 #       - or -
22 #       make -f Makefile.install rhel
23 #       - or -
24 #       make -f Makefile.install fedora14
25 #
26 # Notes:
27 #
28 #       This makefile has been tested much more with Ubuntu and Debian than
29 #   CentOS, Fedora, or RHEL.
30 #
31 # ---------------------------------------------------------------------
32
33 # Make any assumptions about the shell being used explicit
34 SHELL=/bin/bash 
35
36 # XXX
37 # Gentoo needs explicit versions on many of these packages
38 # to simulate a "blessed" set of packages
39
40 # 64 or 32 bit os?
41 LBITS=$(shell getconf LONG_BIT)
42
43 # ejabberd is not packaged on CentOS/RHEL, so we have to
44 # download the installable package from the source
45 EJABBERD_VER=2.1.2
46 EJABBERD_PKG=ejabberd-2.1.2-linux-x86-installer.bin
47 EJABBERD_PKG_x64=ejabberd-2.1.2-linux-x86_64-installer.bin
48 EJABBERD_HOST=http://www.process-one.net/downloads/ejabberd
49
50 # Centos and Redhat will require the rpmforge repository mostly for memcache and perl modules
51 RPMFORGE_PKG_x64=rpmforge-release-0.5.1-1.el5.rf.x86_64.rpm
52 RPMFORGE_PKG=rpmforge-release-0.5.1-1.el5.rf.i386.rpm
53 RPMFORGE_HOST=http://packages.sw.be/rpmforge-release
54
55 # need newer libtool, autoconf, and automake on centos
56 AUTOCONF_HOST=http://ftp.gnu.org/gnu/autoconf
57 AUTOCONF_PKG=autoconf-2.65
58 LIBTOOL_HOST=http://ftp.gnu.org/gnu/libtool
59 LIBTOOL_PKG=libtool-2.2.6b
60 AUTOMAKE_HOST=http://ftp.gnu.org/gnu/automake
61 AUTOMAKE_PKG=automake-1.11
62
63 # libmemcached is only packaged on newer distros
64 LIBMEMCACHED=libmemcached-0.40
65 LIBMEMCACHED_HOST=http://download.tangent.org
66
67 # XML::LibXSLT fails due to old libxslt
68 XSLT=libxslt-1.1.22
69 XSLT_HOST=ftp://ftp.gnome.org/pub/GNOME/sources/libxslt/1.1
70
71 # libxslt depends on a newer version of libxml2:
72 XML2=libxml2-2.6.30
73 XML2_HOST=ftp://ftp.gnome.org/pub/GNOME/sources/libxml2/2.6
74
75 APT_TOOL=aptitude -yq
76
77 # Debian dependencies
78 DEBS =  \
79         apache2-mpm-prefork\
80         apache2-prefork-dev\
81         autoconf\
82         automake\
83         build-essential\
84         check\
85         ejabberd\
86         less\
87         libapache2-mod-perl2\
88         libcache-memcached-perl\
89         libclass-dbi-abstractsearch-perl\
90         libclass-dbi-sqlite-perl\
91         libdatetime-format-builder-perl\
92         libdatetime-format-mail-perl\
93         libdatetime-perl\
94         libdatetime-timezone-perl\
95         liberror-perl\
96         libexpat1-dev\
97         libfile-find-rule-perl\
98         libgcrypt11-dev \
99         libgdbm-dev \
100         liblog-log4perl-perl\
101         libmodule-build-perl\
102         libnet-jabber-perl\
103         libperl-dev\
104         libreadline5-dev\
105         librpc-xml-perl\
106         libtemplate-perl\
107         libtest-pod-perl\
108         libtie-ixhash-perl\
109         libtool\
110         libuniversal-require-perl\
111         libunix-syslog-perl\
112         libwww-perl\
113         libxml2-dev\
114         libxml-libxml-perl\
115         libxml-libxslt-perl\
116         libxml-simple-perl\
117         libxslt1-dev\
118         memcached\
119         pkg-config\
120         psmisc\
121         python-dev\
122         python-libxml2\
123         python-setuptools\
124         zlib1g-dev
125
126 CENTOS = \
127         apr-util-devel \
128         autoconf \
129         automake \
130         gcc \
131         gcc-c++ \
132         gdbm-devel \
133         httpd-devel \
134         less \
135         libmemcache-devel \
136         libtool \
137         libxml2-devel \
138         libxslt-devel \
139         make \
140         memcached \
141         mod_perl \
142         mod_ssl \
143         ncurses \
144         ncurses-devel \
145         perl-Cache-Memcached \
146         perl-Class-DBI-AbstractSearch \
147         perl-Class-DBI-SQLite \
148         perl-DateTime \
149         perl-DateTime-Format-ISO8601 \
150         perl-DateTime-Format-Mail \
151         perl-DateTime-Set \
152         perl-DateTime-TimeZone \
153         perl-DBI \
154         perl-Email-Send \
155         perl-Error \
156         perl-File-Find-Rule \
157         perl-JSON-XS \
158         perl-libwww-perl \
159         perl-Log-Log4perl \
160         perl-Memcached-libmemcached \
161         perl-Module-Build \
162         perl-Net-Server \
163         perl-Template-Toolkit \
164         perl-Test-Pod \
165         perl-Tie-IxHash \
166         perl-UNIVERSAL-require \
167         perl-Unix-Syslog \
168         perl-XML-Parser \
169         psmisc \
170         python-devel \
171         python-setuptools\
172         readline-devel \
173         wget
174
175 CENTOS_PERL = \
176         Net::Jabber \
177         Net::XMPP \
178         RPC::XML \
179         XML::LibXML \
180         XML::LibXSLT \
181         XML::Simple
182
183 FEDORAS = \
184         autoconf \
185         automake \
186         check \
187         check-devel \
188         ejabberd \
189         expat-devel \
190         gcc \
191         gdbm-devel \
192         httpd \
193         httpd-devel \
194         less \
195         libgcrypt-devel \
196         libmemcached \
197         libmemcached-devel \
198         libtool \
199         libxml2-devel \
200         libxml2-python \
201         libxslt-devel \
202         make \
203         memcached \
204         mod_perl \
205         perl-Cache-Memcached \
206         perl-Class-DBI \
207         perl-Class-DBI-AbstractSearch \
208         perl-Class-DBI-SQLite \
209         perl-DateTime-Format-Builder \
210         perl-DateTime-Format-ISO8601 \
211         perl-DateTime-Format-Mail \
212         perl-DateTime-Set \
213         perl-devel \
214         perl-Error \
215         perl-File-Find-Rule \
216         perl-JSON-XS \
217         perl-libwww-perl \
218         perl-Log-Log4perl \
219         perl-Module-Build \
220         perl-Net-Jabber \
221         perl-Net-Server \
222         perl-RPC-XML \
223         perl-SQL-Abstract-Limit \
224         perl-Template-Toolkit \
225         perl-Test-Deep \
226         perl-Test-Exception \
227         perl-Test-Pod \
228         perl-Tie-IxHash \
229         perl-UNIVERSAL-require \
230         perl-Unix-Syslog \
231         perl-XML-LibXML \
232         perl-XML-LibXSLT \
233         perl-XML-Simple \
234         psmisc \
235         python-devel \
236         python-dns \
237         python-memcached \
238         python-setuptools \
239         python-simplejson \
240         readline-devel
241
242 DEB_APACHE_MODS = \
243         ssl
244
245 EXTRA_DEBS = \
246         libdatetime-format-iso8601-perl \
247         libjson-xs-perl \
248         libnet-server-perl
249
250 EXTRA_DEBS_SQUEEZE = \
251         libmemcached-dev \
252         libmemcached-tools \
253         libxml-libxml-perl \
254         libxml-libxslt-perl
255
256 EXTRA_DEBS_UBUNTU_LUCID = \
257         libmemcached-dev\
258         libxml-libxml-perl \
259         libxml-libxslt-perl
260
261 # generic CPAN modules:
262 #   * DateTime::Format::ISO8601 is packaged by both Debian Lenny and Ubuntu Intrepid
263 #   * JSON::XS is packaged by both Debian Lenny and Ubuntu Intrepid
264 #   * libnet-server-perl 0.97 is packaged on Debian Lenny and Ubuntu Intrepid
265 #     - is there a specific need for 0.90?
266 CPAN_MODULES = \
267         DateTime::Format::ISO8601 \
268         RHANDOM/Net-Server-0.90.tar.gz \
269         JSON::XS
270
271 #   libxml-libxml-perl on Debian Lenny and Ubuntu Intrepid is 1.66, which
272 #   has broken namespace handling. so we still need to install these from
273 #   CPAN. *sigh*
274 CPAN_MODULES_XML = \
275         XML::LibXML \
276         XML::LibXSLT
277
278 # ----------------------------------------------------------------------------
279
280 all: 
281         @echo "please specify an OS" && exit 0
282
283
284 centos: install_rpmforge install_centos_rpms install_ejabberd install_buildutils install_libmemcached install_libxml2 install_libxslt install_centos_perl create_ld_local
285
286 debian-lenny: generic_debian install_cpan_xml lenny install_libmemcached
287 debian-squeeze: generic_debian squeeze
288 lenny: install_extra_debs
289 squeeze: install_extra_debs_squeeze
290 generic_debian: install_debs debian_sys_config
291
292 fedora14: install_fedora_rpms
293
294 rhel: centos
295
296 ubuntu-hardy: generic_ubuntu install_cpan_xml hardy
297 ubuntu-lucid: generic_ubuntu lucid
298 hardy: install_cpan install_libmemcached 
299 lucid: install_extra_debs install_extra_debs_lucid
300 generic_ubuntu: install_debs debian_sys_config
301
302 # - COMMON TARGETS ---------------------------------------------------------
303
304 # Install the CPAN modules
305 install_cpan: 
306         for m in $(CPAN_MODULES); do perl -MCPAN -e "install \"$$m\";"; done
307
308 # Install CPAN modules that need to be forced
309 install_cpan_force: 
310         for m in $(CPAN_MODULES_FORCE); do perl -MCPAN -e "CPAN::Shell->force(qw#install $$m#);"; done
311
312 # Install the CPAN XML modules
313 install_cpan_xml: 
314         for m in $(CPAN_MODULES_XML); do perl -MCPAN -e "install \"$$m\";"; done
315
316 # Install ejabberd from official project installer binary
317 install_ejabberd:
318         if [ $(LBITS) -eq 64 ]; then \
319                 if [ ! -f $(EJABBERD_PKG_x64).gz ]; then \
320                         wget $(EJABBERD_HOST)/$(EJABBERD_VER)/$(EJABBERD_PKG_x64).gz; \
321                 fi; \
322                 gunzip $(EJABBERD_PKG_x64).gz; \
323                 chmod u+x $(EJABBERD_PKG_x64); \
324                 ./$(EJABBERD_PKG_x64) --mode unattended --prefix /opt/ejabberd --adminpw opensrf ; \
325         fi;
326         if [ $(LBITS) -eq 32 ]; then \
327                 if [ ! -f $(EJABBERD_PKG).gz ]; then \
328                         wget $(EJABBERD_HOST)/$(EJABBERD_VER)/$(EJABBERD_PKG).gz; \
329                 fi; \
330                 gunzip $(EJABBERD_PKG).gz; \
331                 chmod u+x $(EJABBERD_PKG); \
332                 ./$(EJABBERD_PKG) --mode unattended --prefix /opt/ejabberd --adminpw opensrf ; \
333         fi;
334
335 # Install rpmforge for redhat and centos
336 install_rpmforge:
337         if [ $(LBITS) -eq 64 ]; then \
338                 if [ ! -f $(RPMFORGE_PKG_x64) ]; then \
339                         wget $(RPMFORGE_HOST)/$(RPMFORGE_PKG_x64) ; \
340                         yum -y remove subversion*i386 ; \
341                 fi; \
342                 rpm -Uvh --force ./$(RPMFORGE_PKG_x64) ; \
343         fi;
344         if [ $(LBITS) -eq 32 ]; then \
345                 if [ ! -f $(RPMFORGE_PKG) ]; then \
346                         wget $(RPMFORGE_HOST)/$(RPMFORGE_PKG) ; \
347                 fi; \
348                 rpm -Uvh --force ./$(RPMFORGE_PKG) ; \
349         fi;
350         yum update -y
351
352 # Install automake, autoconf, and libtool
353 install_buildutils:
354         if [ ! -f $(LIBTOOL_PKG).tar.gz ]; then wget $(LIBTOOL_HOST)/$(LIBTOOL_PKG).tar.gz; fi;
355         tar zxf $(LIBTOOL_PKG).tar.gz
356         cd $(LIBTOOL_PKG) && ./configure --prefix=/usr && make && make install
357
358         if [ ! -f $(AUTOCONF_PKG).tar.gz ]; then wget $(AUTOCONF_HOST)/$(AUTOCONF_PKG).tar.gz; fi;
359         tar zxf $(AUTOCONF_PKG).tar.gz
360         cd $(AUTOCONF_PKG) && ./configure --prefix=/usr && make && make install
361         
362         if [ ! -f $(AUTOMAKE_PKG).tar.gz ]; then wget $(AUTOMAKE_HOST)/$(AUTOMAKE_PKG).tar.gz; fi;
363         tar zxf $(AUTOMAKE_PKG).tar.gz
364         cd $(AUTOMAKE_PKG) && ./configure --prefix=/usr && make && make install
365
366 # Install libmemcached from the official project source
367 install_libmemcached:
368         if [ ! -f $(LIBMEMCACHED).tar.gz ]; then wget $(LIBMEMCACHED_HOST)/$(LIBMEMCACHED).tar.gz; fi;
369         tar xzf $(LIBMEMCACHED).tar.gz
370         cd $(LIBMEMCACHED) && ./configure && make && make install
371
372 # Install a newer version of libxslt
373 install_libxslt:    
374         if [ ! -d $(XSLT) ]; then wget $(XSLT_HOST)/$(XSLT).tar.gz; fi;
375         tar xzf $(XSLT).tar.gz
376         cd $(XSLT) && ./configure --with-libxml-prefix=/usr/local && make && make install
377
378 # Install a newer version of libxml2
379 install_libxml2:    
380         if [ ! -d $(XML2) ]; then wget $(XML2_HOST)/$(XML2).tar.gz; fi;
381         tar xzf $(XML2).tar.gz
382         cd $(XML2) && ./configure && make && make install
383
384 clean:
385         make -C $(LIBJS_PERL) clean
386         make -C $(XML2) clean
387         make -C $(XSLT) clean
388         make -f Makefile.ref -C js/src/ clean
389
390
391 # ------------------------------------------------------------------
392 # - DEBIAN ---------------------------------------------------------
393
394 debian_sys_config: 
395         # link the apache modules in
396         for m in $(DEB_APACHE_MODS); do a2enmod $$m; done;
397
398         # adds a placeholder module so apxs will be happy
399         if [ ! "$$(grep mod_placeholder /etc/apache2/httpd.conf)" ]; then \
400                 echo -e "#\n#LoadModule mod_placeholder /usr/lib/apache2/modules/mod_placeholder.so" \
401                         >> /etc/apache2/httpd.conf; \
402         fi;
403
404 # Install the debian-specific dependencies
405 install_debs:
406         $(APT_TOOL) install $(DEBS)
407
408 # Install the debian-specific dependencies for more modern distros
409 install_extra_debs:
410         $(APT_TOOL) install $(EXTRA_DEBS)
411
412 install_extra_debs_squeeze: install_extra_debs
413         $(APT_TOOL) install $(EXTRA_DEBS_SQUEEZE)
414
415 # Install even more packaged dependencies on modern distros
416 install_extra_debs_lucid:
417         $(APT_TOOL) install $(EXTRA_DEBS_UBUNTU_LUCID)
418
419 # Fedora
420 install_fedora_rpms:
421         yum -y install $(FEDORAS)
422
423 # CENTOS
424 install_centos_rpms:
425         yum -y install $(CENTOS)
426         yum -y update
427
428 install_centos_perl:
429         for m in $(CENTOS_PERL_FORCE); do perl -MCPAN -e "CPAN::Shell->force(qw#install $$m#);"; done
430         for m in $(CENTOS_PERL); do perl -MCPAN -e "install \"$$m\";"; done
431         for m in $(CENTOS_PERL_VERSION); do perl -MCPAN -e "CPAN::Shell->install \"$$m\";"; done
432         for m in $(CENTOS_PERL_NOTEST); do perl -MCPAN -e "CPAN::Shell->notest('install', \"$$m\";"; done
433         for m in $(CENTOS_PERL_LOCAL); do LD_LIBRARY_PATH=/usr/local/lib:/usr/lib:/lib perl -MCPAN -e "install \"$$m\";"; done
434
435 # We need to add /usr/local/lib to the ldconfig list of directories on CentOS,
436 # if it is not already there
437 create_ld_local:
438         if [ "$$(ldconfig -v 2> /dev/null | grep '^/usr/local/lib' | wc -l)" -eq 0 ]; then \
439                 echo '/usr/local/lib' > /etc/ld.so.conf.d/local.conf; \
440                 ldconfig; \
441         fi;
442
443 # vim:noet:sw=4:ts=4: